#include <cstdio>
#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

const int mod = 1e9 + 7;

int main() {
 	freopen("adding.in", "r", stdin);
	freopen("adding.out", "w", stdout);

	int n, m;
	scanf("%d%d", &n, &m);
	assert(1 <= n * m && n * m <= 300);
	vector<vector<int> > a(n, vector<int>(m));
	for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) scanf("%d", &a[i][j]);
	int k;
	scanf("%d", &k);
	assert(1 <= k && k <= 300);
	for (int i = 0; i < k; i++) {
	 	int x, y;
		scanf("%d%d", &x, &y);
		--x; --y;
		for (int j = 0; j < m; j++) {
		 	a[x][j] = (a[x][j] + a[y][j]) % mod;
		}
	}	
	for (int i = 0; i < n; i++, cout << endl) for (int j = 0; j < m; j++) cout << a[i][j] << " ";

	return 0;
}