#include<iostream>
#include<cstdio>
#include<cassert>
#include<cmath>
#include<ctime>
#include<algorithm>
#include<vector> 
#include<cstring>
#include<string>
#include<map>
#include<set>

#define mp make_pair
#define scn second
#define frs first
#define pb push_back

#define NAME "downloading"

using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef pair<ll, int> pi;
const int P = 239017;
const ll INF = 1000000000ll * 1000000000;
const int MAX = 2000 + 10;
const long double DINF = (long double)INF;

                  
vector<int> arr;
int n, v;
int t[1000000], w[1000000];
double ans[1000000];

bool cmp(int a, int b) {
	return t[a] < t[b];
}

	
                        
int main() {
    freopen(NAME ".in", "r", stdin); 
    freopen(NAME ".out", "w", stdout);     
	scanf("%d%d", &n, &v);
	for (int i = 0; i < n; ++i) {
		scanf("%d%d", &t[i], &w[i]);
	}
	for (int i = 0; i < n; ++i)
		arr.pb(i);
	sort(arr.begin(), arr.end(), cmp);
	set<pair<long double, int> > q;
	long double add = 0;
	double now_time = 0;
	int y = 0;
	while (y < n || q.size() > 0) {
		if (q.size() == 0) {			
			q.insert(mp(add + w[arr[y]], arr[y]));
			now_time = t[arr[y]];
			++y;
			continue;
		}
		pair<long double, int> tmp = *(q.begin());
		double speed = v * 1.0 / q.size();
		if (y == n || (tmp.frs - add) / speed < t[arr[y]] - now_time) {
			now_time = now_time + (tmp.frs - add) / speed;
			add += (tmp.frs - add);
			ans[tmp.scn] = now_time;
			q.erase(tmp);
		} else {
		    add += (t[arr[y]]*1.0-now_time) * speed;
			now_time = t[arr[y]];
			q.insert(mp(add + w[arr[y]], arr[y]));
			++y;
		}
	}				
	for (int i = 0; i < n; ++i) {
	 	printf("%1.6lf\n", ans[i]);
	}


    return 0;
}

/*
for (int i = 0; i < arr.size(); ++i) {
		int now = arr[i];
		if (q.size() > 0) {
			double speed = v * 1.0 / q.size();
			int delta = t[arr[i]] - now_time;
			pair<long double, int> tmp = *(q.begin());
			while (q.size() > 0 && (tmp.frs-add) / speed < delta) {
				int nmb = tmp.scn;
				ans[nmb] = now_time * 1.0 + (tmp.frs-add) / speed;
				q.erase(tmp);
				speed = v * 1.0 / q.size();			
				tmp = *(q.begin());			
			}
		}	
		now_time = t[arr[i]];
		q.insert(mp(add + w[now], now));		
	}
*/





